#undef OLD_TEXT

/* Commands sent to marcommand() */

#define DRIVE_PHI		(0)
#define SET_PHI			(1)
#define DRIVE_DISTANCE		(2)
#define SET_DISTANCE		(3)
#define OPEN_SHUTTER		(4)
#define CLOSE_SHUTTER		(5)
#define STOP			(6)
#define ABORT			(7)
#define INITIALIZE		(8)
#define ERASE			(9)
#define SCAN			(10)
#define FLUSH_QUEUE		(11)
#define LIST_QUEUE		(12)
#define CONFIGURE		(13)
#define DRIVE_OFFSET    	(14)
#define SET_OFFSET      	(15)
#define	DRIVE_PHI_REL		(16)
#define DRIVE_KAPPA		(17)
#define SET_KAPPA		(18)
#define DRIVE_OMEGA		(19)
#define SET_OMEGA		(20)
#define HOME			(21)
#define GON_MANUAL		(22)
#define DRIVE_WAVELENGTH	(23)
#define SET_WAVELENGTH		(24)
#define CONFIG			(25)
#define LOCK_SPINDLE		(26)
#define UNLOCK_SPINDLE		(27)
#define AUTO_MOUNT		(28)
#define AUTO_DISMOUNT		(29)
#define AUTO_DISMOUNT_NOEOC	(30)
#define HOME_AUTOMT		(31)
#define WARM_AUTOMT		(32)
#define WARM_AUTOMT_NEOC	(33)
#define CHILL_AUTOMT		(34)
#define LOADPOS_AUTOMT		(35)
#define USEPOS_AUTOMT		(36)
#define HEATON_AUTOMT		(37)
#define HEATOFF_AUTOMT		(38)
#define CENTER_AUTOMT		(39)
#define STATUS_AUTOMT		(40)
#define LASON_AUTOMT		(41)
#define LASOFF_AUTOMT		(42)
#define LASCAL_AUTOMT		(43)
#define LASBYPOFF_AUTOMT	(44)
#define LASBYPON_AUTOMT		(45)
#define CHILBYPOFF_AUTOMT	(46)
#define CHILBYPON_AUTOMT	(47)
#define BS_MOVEH		(48)
#define BS_MOVEV		(49)
#define RESET_CM		(50)
#define HOME_CM			(51)
#define STOP_CM			(52)
#define EXIT			(53)

#define TIME_MODE		(0)	/* Collect in time mode */
#define DOSE_MODE		(1)	/* Collect in dose mode */
#define COMP_NONE 		(0)	/* No compression */
#define COMP_Z    		(1)	/* Unix .Z compression */
#define COMP_PCK  		(2)	/* Mar .pck compression */

#define CONFIG_1x1  		(0)	/* single module ccd */
#define CONFIG_2x2  		(1)	/* 2x2 ccd */
#define CONFIG_DEFAULT 		(0)	/* default */
#define MAR_SMALL 	 	(0)	/* Small Scanner (180) */
#define MAR_LARGE 		(1)	/* Large Scanner (300) */

#define RDSN		(3)	/* Command codes for ED2 distance readout */
#define RADDR		(6)
#define AADDR		(7)
#define ED2RDPOS1	(16)

#define SNAP_CENTER	(1)
#define RUN_CENTER	(2)
#define RESTART_CENTER	(3)
#define WAVE_MISMATCH 	(4)
#define DIST_MISMATCH1	(5)
#define DIST_MISMATCH2	(6)
#define DIST_MISMATCH3	(7)
#define DIST_MISMATCH4	(8)
#define PIN_MISMATCH	(9)
#define BAD_EXPOSURE1	(10)
#define BAD_EXPOSURE2	(11)

#define AC_SCREENA	(1)
#define AC_SCREENB	(2)
#define AC_SCREENC	(3)
#define AC_SCREEND	(4)
#define AC_SCREENALL	(5)
#define AC_SCREENNA	(6)
#define AC_SCREENNB	(7)
#define AC_SCREENNC	(8)
#define AC_SCREENND	(9)
#define AC_SCREENNONE	(10)
#define AC_COLLA	(11)
#define AC_COLLB	(12)
#define AC_COLLC	(13)
#define AC_COLLD	(14)
#define AC_COLLALL	(15)
#define AC_COLLNA	(16)
#define AC_COLLNB	(17)
#define AC_COLLNC	(18)
#define AC_COLLND	(19)
#define AC_COLLNONE	(20)
#define AC_MODENORM	(21)
#define AC_MODETEST	(22)

#define MOUNT_PHI	(225.0)
#define MIN_EXPOSURE	(0.5)
#define MAX_EXPOSURE	(300.0)
#define SCAN_COL_1	(1)
#define XSCAN_COL_2	(15)
#define RSCAN_COL_2	(15)

/* Initial Positions for Windows ( Relative to upper right corner ) */

#define MAIN_X			(-402)
#define MAIN_Y			(0)
#define STATUSDIALOG_X		(-259)
#define STATUSDIALOG_Y		(32)
#define MANUALCONTROLDIALOG_X	(-900)
#define MANUALCONTROLDIALOG_Y	(150)
#define SNAPSHOTDIALOG_X	(-850)
#define SNAPSHOTDIALOG_Y	(200)
#define STRATEGYDIALOG_X	(-800)
#define STRATEGYDIALOG_Y	(250)
#define OPTIONSDIALOG_X		(-446)
#define OPTIONSDIALOG_Y		(336)
#define PROJECTDIALOG_X		(-600)
#define PROJECTDIALOG_Y		(250)
#define OPTIMIZEDIALOG_X	(-600)
#define OPTIMIZEDIALOG_Y	(350)
#define METHOD_FSB_X		(-650)
#define METHOD_FSB_Y		(450)
#define LOCALDIALOG_X		(-850)
#define LOCALDIALOG_Y		(200)

#define ADX_HELP_X		(-750)
#define ADX_HELP_Y		(300)

#define ERRORDIALOG_X		(-825)
#define ERRORDIALOG_Y		(400)

#define DISKFULL_DIALOG_X	(-480)
#define DISKFULL_DIALOG_Y	(506)

#define MAD_DIALOG_X		(-550)
#define MAD_DIALOG_Y		(200)

#define TIMER_MSEC		(1000) /* Timer interval to read status file */

#define N_FIELDS 		(13)	/* Number of fields in Runs window */
#define BAD_FIELD		(-9999)
#define FIELD_INT		(0)
#define FIELD_FLOAT		(1)

/* Maximum number of characters (including newline) per line */
#define MAX_CHAR		(beamline_mode==True?M_MAX_CHAR:90) 
#define M_MAX_CHAR		(118) 

/* #define FIELD_LENGTH(i) 	(fld[i].col_end-fld[i].col_start+1) */
#define SPACE_CHAR 		' '

#define MAX_RUNS		(999)	/* Maximum Run number */
#define MAX_ROWS		(128)	/* Max rows in table of runs */
#define M_RUNS			(10)	/* Max Run's used in completion calculation */
#define MAX_FRAMES		(999)	/* Maximum # of frames in each run for completion calculation */

#define DOSE_SCALE		(1.0)	/* Conversion from dose to time */

#define WEAK_BEAM		(10.0)	/* Threshold for a "weak beam" */

#define PHI_AXIS		(0)
#define KAPPA_AXIS		(1)
#define OMEGA_AXIS		(2)

#define MAX_COLD_MOUNTS		(10)      /* Max times to mount xtal with */
                                          /* gripper cold */

#define label_font "-*-lucida-medium-r-*-*-*-180-75-75-*-*-iso8859-1"
#define scan_font "-*-courier-medium-r-*-*-*-120-75-75-*-*-iso8859-1"
#define fixedf "fixed"

/* Scanner configuration information. Configuration file 
 * is specified in the environment variable MARCONFIGFILE. 
 * This is usually $MARHOME/tables/config
 */

typedef struct {
	float read_fast;
	float read_slow;
	float read_overhead;
	float bin_factor;
	int blocks;
	int pixelsx;
	int pixelsy;
	double multiplier;
	int phisteps;
	int diststeps;
	int phitop;
	int disttop;
	int distmax;
	int distmin;
	int unitsec;
	int dose_variant;
	float wavelength;
	int usedistance;
	int use2theta;
	int usephi;
	int usekappa;
	int useomega;
	int usewavelength;
	int flags;
	int nc_pointer;
	int nc_index;
	int nc_x;
	int nc_y;
	int nc_rec;
	int nc_poff;
	int scsi_id;
	int scsi_controller;
	int spiral_check;
	int twothetamin;
	int twothetamax;
	int twothetatop;
	int twothetasteps;
	int dezinger;

	/*   0 - do nothing
	 * 180 - values from -180 to +180
	 * 360 - values from 0 to 360
	 */
	int constrain_kappa;
	int constrain_omega;
	int constrain_phi;
	float pixelsize;
	int usezero_angles;
	int usegoniostat;
	int useautomount;
	int daemon_exit;
	int allow_binned;
	int allow_32bit;
	int allow_pad_use;
	int prefer_SWbinning;
	int max_rem_chars;
} ScannerConfig;

typedef struct {
	int col_start;
	int col_end;
	int space;
} FieldStruct;

typedef struct {
	char automt[32];  /* Blank or N if no automounter, otherwise puck/pin */
	int number;  /* Run Number */
	char ac_code[4];
	int start;   /* Starting Frame */
	int nframes; /* Number of Frames */
	double distance;
	double offset;
	double phi;
	double kappa;
	double omega;
	char axis[32];
	double delta_phi;
	double exposure;
	char dzngr[8];
	char blstr[256];
} RunStruct;


typedef struct {
	int mode;
	int bin;
	int adc;
	int no_transform;
	int output_raw;
	char directory[256];
	char prefix[64];
	char suffix[32];
	double wavelength;
	double step_size; /* Added by Marian */
	int dk_mode;
	char dark_filename[256];
	int sweeps;

	int compression;
	int anomalous;
	int wedge;
	float center_x[4], center_y[4];
	int outfile_type;
	int dk_before_run;
	int repeat_dark;
	int darkinterval;

	int mad_mode;
	int mad_nwave;
	float mad_ndegs;
	float mad_wavelengths[10];
} CollectStruct;

typedef struct {
	double twothetamin;
	double twothetamax;
	double distmin;
	double distmax;
} LimitStruct;

typedef struct {
	short run_no;
	short frame_no;
} Run_List;

int wtoi();	/* TextField widget to integer */
double wtof();	/* TextField widget to float */
double atof();
double TextFieldGetFloat();
void exit_activateCallback();
void ac_ID_activateCallback();
void ac_list_focusCallback();
void ac_list_losefocusCallback();
void ac_order_activateCallback();
void ac_width_activateCallback();
void ac_time_activateCallback();
void ac_degs_activateCallback();
void runitem_activateCallback();
void runitem_modifyCallback();
void runitem_focusCallback();
void runitem_losefocusCallback();
void runitem_exposeCallback();
int clean_up_item(char * str, int row, int field);
int clean_up_ac_ID(char * str, int row);
int clean_up_ac_order(char * str, int row);
int clean_up_ac_float(char * str, int row, int digt, int dig2);
void make_new_row(int flag);
double read_distance();
void show_energy_scan(char * filenm, int scan_type, int scan_num, int col1,
 int col2, float show_edge, float show_peak, int retry);

#ifdef DECLARE_ADX_GLOBALS
#define GLOBAL
#else
#define GLOBAL extern
#endif

GLOBAL XtAppContext app_contxt;
GLOBAL Widget parent;
GLOBAL GC labelGC, scanGC, whiteGC, redGC;
GLOBAL Font fontlabel, fontscan;
GLOBAL XFontStruct *fontlabelStruct, *fontscanStruct;

GLOBAL ScannerConfig sc_conf;
/* GLOBAL FieldStruct fld[N_FIELDS+1];	 +1 for beamline_mode */

GLOBAL char image_directory[256];
GLOBAL char image_prefix[256];
GLOBAL char image_suffix[256];

GLOBAL double current_distance;	 /* Current Distance */
GLOBAL double save_new_distance; /* Distance to move to, saved during check */
GLOBAL double current_phi;	 /* Current Phi */
GLOBAL double current_kappa;	 /* Current Kappa */
GLOBAL double current_omega;	 /* Current Omega */
GLOBAL double current_offset;	 /* Current Offset */
GLOBAL double wavelength;	 /* Wavelength */
GLOBAL double delta_phi;	 /* Oscillation width */
GLOBAL double phi_step;	 	 /* Step size */

GLOBAL double beam_intensity;	 /* Beam Intensity */
GLOBAL double beam_intensity_0;	 /* Beam Intensity at start of run */
GLOBAL char image_filename[256]; /* Image File Name */
GLOBAL char image_prev_filename[256]; /* Previous Image File Name */
GLOBAL char distance_filename[256]; /* File where current distance is kept */
GLOBAL int serialfd;	/* File descriptor for serial port connected to */
                        /* distance readout */

GLOBAL RunStruct Run[MAX_RUNS+1]; /* Run information for each run */
GLOBAL CollectStruct Collect;	 /* Information for each set of runs */
GLOBAL LimitStruct Limit;	 /* Limits for 2theta & distance */

GLOBAL Run_List run_list[M_RUNS * MAX_FRAMES];
GLOBAL int n_detectors;
GLOBAL char detector_letter[4];
GLOBAL int total_images;

GLOBAL int configuration;	 /* CONFIG_1x1 or CONFIG_2x2 */
GLOBAL int image_collect_mode;	 /* TIME_MODE or DOSE_MODE */
GLOBAL int image_adc_mode;	 /* 0 or 1 */
GLOBAL int image_bin_mode;	 /* 1 or 2 */
GLOBAL int xform_mode;		 /* 1 or 2 */
GLOBAL int saveraw_mode;	 /* 1 or 2 */
GLOBAL int image_compression;	 /* COMP_NONE, COMP_Z or COMP_PCK */
GLOBAL int outfile_type;	 /* 0 (16), 1 (32), 2 (16 + ovf) */
GLOBAL int osc_sweeps;	 	 /* 1 or 4 */
GLOBAL int digits_per_frameno;	 /* Digits for frame no. part of filename */
GLOBAL int automt_status;	 /* Automounter status: -99 for none, -1 for */
                                 /* present but disabled, 0 for enabled but */
				 /* no pin mounted, higher is number of */
				 /* mounted pin + 100 * puck #  + 1000 if pin */
                                 /* is centered */
GLOBAL int prev_automt_status;   /* Saved automounter status, for use if a */
                                 /* dismount fails */
GLOBAL int puck_no;		 /* Puck for mounting or dismounting xtal */
GLOBAL int pin_no;		 /* Pin in puck where xtal is */
GLOBAL int new_puck_no, new_pin_no;  /* Settings from menu in Man Control */
GLOBAL int gripper_warm;         /* 0/1 for gripper cold/warm */
GLOBAL int mount_count;          /* Count of cold (screening) mounts done */
GLOBAL int automt_posn;          /* Position of automounter, 0/1 for load/use */
GLOBAL int auto_restart;         /* 0/1 for no/yes allow automatic restart */
                                 /* after stop due to low counts */
GLOBAL int test_automt_only;     /* 0/1 for normal/test mode, doing automt */
                                 /* functions but no data collection  */
GLOBAL int pad_in_use;           /* -1/0/1 for no PAD/PAD present but not */
                                 /* selected/PAD in use */
GLOBAL Display *display;
GLOBAL int scr_width;	 	 /* Width of Screen (in pixels) */
GLOBAL int scr_height;	 	 /* Height of Screen (in pixels) */

GLOBAL char tmpstr[256];	 /* Temporary storage string */
GLOBAL char error_msg[1024];	 /* Error messages */

GLOBAL char marcommandfile[128]; /* MAR Command file */
GLOBAL char marstatusfile[128];  /* MAR Status file */
GLOBAL char marcollectfile[128];  /* MAR Collect file */
GLOBAL char last_file_in_run[256];  /* Name of last image file in current run */
                                    /* list */

GLOBAL FILE *marcommandfp; 	 /* MAR Command file pointer */
GLOBAL FILE *marstatusfp;  	 /* MAR Status file pointer */

GLOBAL int next_start_at_run;	/* Which run in list to do next, for run list */
                                /* split because of automount actions needed */
GLOBAL int start_at_run;	/* First run in the current partial set */
GLOBAL int stop_at_run;		/* Last run in the current partial set */
GLOBAL int runcount;		/* Total number of runs in list */
GLOBAL int collecting;		/* 0/1/2 for idle, collecting, or stopping */
GLOBAL int waiting_for_BL;	/* 0/1 for no/yes waiting for action such as */
                                /* energy scan */
GLOBAL int debug;		/* debug flag */
GLOBAL int beamline_mode;	/* -beamline flag (no hardware) */
GLOBAL int software_mode;	/* -s flag (no hardware) */
GLOBAL int define_distance;	/* -define_distance flag (allow define dist) */
GLOBAL int define_offset;	/* -define_offset flag (allow define offset) */

GLOBAL int n_fields;	/* Number of fields in run setup window */
GLOBAL int n_defined_rows;	/* Number of currently defined rows in run */
                                /* list, i.e. no. of runlist_items widgets */
                                /* which have been created */
GLOBAL int n_current_row;	/* Number of currently selected row */
GLOBAL char *saved_rows[MAX_ROWS];   /* Storage for runs from marcollect, */
GLOBAL int n_saved_rows;        /* to keep them until they can be loaded into */
                                /* runlist_items widgets */
GLOBAL int dezinger;	
GLOBAL int file_overwrite_mode;	 /* 0 - do nothing, 1 - warning, 2 - fatal */
GLOBAL int nocontrol, remote_control;
GLOBAL int show_xray_label;
GLOBAL int wavelength_control_active;
GLOBAL int status_checked;
GLOBAL int distance_checked;
GLOBAL int distance_checked_was;
GLOBAL int return_point;
GLOBAL int stopping_type;
GLOBAL int autocollect_enabled;
GLOBAL int screening_params[5];
GLOBAL int autocol_order[64];
GLOBAL int inhibit_mount_status_change;

/* Set Insertion Point to End of Text Field */
#define XmTextSetInsertionEnd(w) XmTextSetInsertionPosition(w, XmTextGetLastPosition(w))

#define S_WIDTH (200)	/* Increment in width of strategyDialog in beamline_mode */

GLOBAL int calculating_strategy; /* Set when strategy calc is happening */

GLOBAL float beam_x[4], beam_y[4];
GLOBAL float bs_hshift, bs_vshift;
GLOBAL float refscan_edge;
GLOBAL int last_scan_type;
GLOBAL int runs_are_defined;     /* Initially 0, set when collect_runs is run */
GLOBAL int automt_table[4][16][2];
GLOBAL int rl_x[N_FIELDS+1], rl_width[N_FIELDS+1];
GLOBAL char rl_string[N_FIELDS+1][32];
